unit DicePool;

(* Embracer Dice Pool Module
   Copyright (c) 1997 by William E. Sorensen.
   May be distributed for non-commercial purposes.
*)

interface

{ Note that Randomize is called in Main. }

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TDicePoolForm = class(TForm)
    LDifficulty: TLabel;
    EDifficulty: TEdit;
    UDDifficulty: TUpDown;
    LDiceInPool: TLabel;
    EDiceInPool: TEdit;
    LBRolls: TListBox;
    BRoll: TButton;
    UDDiceInPool: TUpDown;
    LRolls: TLabel;
    ResultPanel: TPanel;
    procedure BRollClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  DicePoolForm: TDicePoolForm;

implementation

{$R *.DFM}

uses
  Dice;

procedure TDicePoolForm.BRollClick(Sender: TObject);
var
  Difficulty : Byte;
  DiceInPool : Byte;
  d10        : TDie;
  Successes  : Integer;
  i          : Byte;

begin
  Difficulty := StrToInt(EDifficulty.Text);
  DiceInPool := StrToInt(EDiceInPool.Text);

  LBRolls.Items.Clear;
  ResultPanel.Caption := '';

  d10 := TDie.Create(10);

  try
    Successes := 0;

    for i := 1 to DiceInPool do
      begin
        LBRolls.Items.Add(IntToStr(d10.Roll));

        if d10.Showing >= Difficulty then
          Inc(Successes)
        else if d10.Showing = 1 then
          Dec(Successes);

      end;

  finally
    d10.Free;
  end;

  if Successes < 0 then
    ResultPanel.Caption := '**** BOTCH! ****'
  else if Successes = 0 then
    ResultPanel.Caption := '---- FAILURE (0) ----'
  else if Successes = 1 then
    ResultPanel.Caption := 'Marginal Success (1)'
  else if Successes = 2 then
    ResultPanel.Caption := 'Moderate Success (2)'
  else if Successes = 3 then
    ResultPanel.Caption := 'COMPLETE Success (3)'
  else if Successes = 4 then
    ResultPanel.Caption := 'EXCEPTIONAL Success (4)'
  else if Successes = 5 then
    ResultPanel.Caption := 'PHENOMENAL Success! (5)'
  else
    ResultPanel.Caption := 'OUTRAGEOUS SUCCESS!!!! (' +
                           IntToStr(Successes) + ')';

end;

end.
